package api

import (
	"github.com/gin-gonic/gin"
	"github.guxuan/haibei/internal/mods/activity/biz"
	"github.guxuan/haibei/internal/mods/activity/schema"
	"github.guxuan/haibei/pkg/util"
)

// Defining the `Questionnaire` api.
type Questionnaire struct {
	QuestionnaireBIZ *biz.Questionnaire
}

// @Tags 问卷模块
// @Security ApiKeyAuth
// @Summary Query questionnaire list
// @Param current query int true "pagination index" default(1)
// @Param pageSize query int true "pagination size" default(10)
// @Success 200 {object} util.ResponseResult{data=[]schema.Questionnaire}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/questionnaires [get]
func (a *Questionnaire) Query(c *gin.Context) {
	ctx := c.Request.Context()
	var params schema.QuestionnaireQueryParam
	if err := util.ParseQuery(c, &params); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.QuestionnaireBIZ.Query(ctx, params)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResPage(c, result.Data, result.PageResult)
}

// @Tags 问卷模块
// @Security ApiKeyAuth
// @Summary Get questionnaire record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult{data=schema.Questionnaire}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/questionnaires/{id} [get]
func (a *Questionnaire) Get(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	item, err := a.QuestionnaireBIZ.Get(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, item)
}

// @Tags 问卷模块
// @Security ApiKeyAuth
// @Summary Create questionnaire record
// @Param body body schema.QuestionnaireForm true "Request body"
// @Success 200 {object} util.ResponseResult{data=schema.Questionnaire}
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/questionnaires [post]
func (a *Questionnaire) Create(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.QuestionnaireForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.QuestionnaireBIZ.Create(ctx, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, result)
}

// @Tags 问卷模块
// @Security ApiKeyAuth
// @Summary Update questionnaire record by ID
// @Param id path string true "unique id"
// @Param body body schema.QuestionnaireForm true "Request body"
// @Success 200 {object} util.ResponseResult
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/questionnaires/{id} [put]
func (a *Questionnaire) Update(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.QuestionnaireForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.QuestionnaireBIZ.Update(ctx, id, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}

// @Tags 问卷模块
// @Security ApiKeyAuth
// @Summary Delete questionnaire record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/questionnaires/{id} [delete]
func (a *Questionnaire) Delete(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.QuestionnaireBIZ.Delete(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}
